]> CyberLeo.Net >> Repos - FreeBSD/FreeBSD.git/blob - libexec/rc/rc.subr
Update timezone database information.
[FreeBSD/FreeBSD.git] / libexec / rc / rc.subr
1 # $NetBSD: rc.subr,v 1.67 2006/10/07 11:25:15 elad Exp $
2 # $FreeBSD$
3 #
4 # Copyright (c) 1997-2004 The NetBSD Foundation, Inc.
5 # All rights reserved.
6 #
7 # This code is derived from software contributed to The NetBSD Foundation
8 # by Luke Mewburn.
9 #
10 # Redistribution and use in source and binary forms, with or without
11 # modification, are permitted provided that the following conditions
12 # are met:
13 # 1. Redistributions of source code must retain the above copyright
14 #    notice, this list of conditions and the following disclaimer.
15 # 2. Redistributions in binary form must reproduce the above copyright
16 #    notice, this list of conditions and the following disclaimer in the
17 #    documentation and/or other materials provided with the distribution.
18 #
19 # THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
20 # ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
21 # TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
22 # PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
23 # BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
24 # CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
25 # SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
26 # INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
27 # CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
28 # ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
29 # POSSIBILITY OF SUCH DAMAGE.
30 #
31 # rc.subr
32 #       functions used by various rc scripts
33 #
34
35 : ${RC_PID:=$$}; export RC_PID
36
37 #
38 #       Operating System dependent/independent variables
39 #
40
41 if [ -n "${_rc_subr_loaded}" ]; then
42         return
43 fi
44
45 _rc_subr_loaded="YES"
46
47 SYSCTL="/sbin/sysctl"
48 SYSCTL_N="${SYSCTL} -n"
49 SYSCTL_W="${SYSCTL}"
50 PROTECT="/usr/bin/protect"
51 ID="/usr/bin/id"
52 IDCMD="if [ -x $ID ]; then $ID -un; fi"
53 PS="/bin/ps -ww"
54 JID=0
55 # rc_service provides the path to the service script that we are executing.
56 # This is not being set here in an execution context, necessarily, so it's
57 # really just a reasonable guess, and it will get overwritten later if
58 # we are executing from some other means than direct execution by service(8)
59 # or manual invocation of the service script.  The prime example of this is
60 # during system startup, all rc scripts will be invoked via /etc/rc, so
61 # run_rc_script will overwrite rc_service with the file being sourced.
62 rc_service="$0"
63
64 #
65 #       functions
66 #       ---------
67
68 # list_vars pattern
69 #       List vars matching pattern.
70
71 list_vars()
72 {
73         set | { while read LINE; do
74                 var="${LINE%%=*}"
75                 case "$var" in
76                 "$LINE"|*[!a-zA-Z0-9_]*) continue ;;
77                 $1) echo $var
78                 esac
79         done; }
80 }
81
82 # set_rcvar [var] [defval] [desc]
83 #
84 #       Echo or define a rc.conf(5) variable name.  Global variable
85 #       $rcvars is used.
86 #
87 #       If no argument is specified, echo "${name}_enable".
88 #
89 #       If only a var is specified, echo "${var}_enable".
90 #
91 #       If var and defval are specified, the ${var} is defined as
92 #       rc.conf(5) variable and the default value is ${defvar}.  An
93 #       optional argument $desc can also be specified to add a
94 #       description for that.
95 #
96 set_rcvar()
97 {
98         local _var
99
100         case $# in
101         0)      echo ${name}_enable ;;
102         1)      echo ${1}_enable ;;
103         *)
104                 debug "set_rcvar: \$$1=$2 is added" \
105                     " as a rc.conf(5) variable."
106                 _var=$1
107                 rcvars="${rcvars# } $_var"
108                 eval ${_var}_defval=\"$2\"
109                 shift 2
110                 eval ${_var}_desc=\"$*\"
111         ;;
112         esac
113 }
114
115 # set_rcvar_obsolete oldvar [newvar] [msg]
116 #       Define obsolete variable.
117 #       Global variable $rcvars_obsolete is used.
118 #
119 set_rcvar_obsolete()
120 {
121         local _var
122         _var=$1
123         debug "set_rcvar_obsolete: \$$1(old) -> \$$2(new) is defined"
124
125         rcvars_obsolete="${rcvars_obsolete# } $1"
126         eval ${1}_newvar=\"$2\"
127         shift 2
128         eval ${_var}_obsolete_msg=\"$*\"
129 }
130
131 #
132 # force_depend script [rcvar]
133 #       Force a service to start. Intended for use by services
134 #       to resolve dependency issues.
135 #       $1 - filename of script, in /etc/rc.d, to run
136 #       $2 - name of the script's rcvar (minus the _enable)
137 #
138 force_depend()
139 {
140         local _depend _dep_rcvar
141
142         _depend="$1"
143         _dep_rcvar="${2:-$1}_enable"
144
145         [ -n "$rc_fast" ] && ! checkyesno always_force_depends &&
146             checkyesno $_dep_rcvar && return 0
147
148         /etc/rc.d/${_depend} forcestatus >/dev/null 2>&1 && return 0
149
150         info "${name} depends on ${_depend}, which will be forced to start."
151         if ! /etc/rc.d/${_depend} forcestart; then
152                 warn "Unable to force ${_depend}. It may already be running."
153                 return 1
154         fi
155 }
156
157 #
158 # checkyesno var
159 #       Test $1 variable, and warn if not set to YES or NO.
160 #       Return 0 if it's "yes" (et al), nonzero otherwise.
161 #
162 checkyesno()
163 {
164         eval _value=\$${1}
165         debug "checkyesno: $1 is set to $_value."
166         case $_value in
167
168                 #       "yes", "true", "on", or "1"
169         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
170                 return 0
171                 ;;
172
173                 #       "no", "false", "off", or "0"
174         [Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|[Oo][Ff][Ff]|0)
175                 return 1
176                 ;;
177         *)
178                 warn "\$${1} is not set properly - see rc.conf(5)."
179                 return 1
180                 ;;
181         esac
182 }
183
184 #
185 # reverse_list list
186 #       print the list in reverse order
187 #
188 reverse_list()
189 {
190         _revlist=
191         for _revfile; do
192                 _revlist="$_revfile $_revlist"
193         done
194         echo $_revlist
195 }
196
197 # stop_boot always
198 #       If booting directly to multiuser or $always is enabled,
199 #       send SIGTERM to the parent (/etc/rc) to abort the boot.
200 #       Otherwise just exit.
201 #
202 stop_boot()
203 {
204         local always
205
206         case $1 in
207                 #       "yes", "true", "on", or "1"
208         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
209                 always=true
210                 ;;
211         *)
212                 always=false
213                 ;;
214         esac
215         if [ "$autoboot" = yes -o "$always" = true ]; then
216                 echo "ERROR: ABORTING BOOT (sending SIGTERM to parent)!"
217                 kill -TERM ${RC_PID}
218         fi
219         exit 1
220 }
221
222 #
223 # mount_critical_filesystems type
224 #       Go through the list of critical filesystems as provided in
225 #       the rc.conf(5) variable $critical_filesystems_${type}, checking
226 #       each one to see if it is mounted, and if it is not, mounting it.
227 #
228 mount_critical_filesystems()
229 {
230         eval _fslist=\$critical_filesystems_${1}
231         for _fs in $_fslist; do
232                 mount | (
233                         _ismounted=false
234                         while read what _on on _type type; do
235                                 if [ $on = $_fs ]; then
236                                         _ismounted=true
237                                 fi
238                         done
239                         if $_ismounted; then
240                                 :
241                         else
242                                 mount $_fs >/dev/null 2>&1
243                         fi
244                 )
245         done
246 }
247
248 #
249 # check_pidfile pidfile procname [interpreter]
250 #       Parses the first line of pidfile for a PID, and ensures
251 #       that the process is running and matches procname.
252 #       Prints the matching PID upon success, nothing otherwise.
253 #       interpreter is optional; see _find_processes() for details.
254 #
255 check_pidfile()
256 {
257         _pidfile=$1
258         _procname=$2
259         _interpreter=$3
260         if [ -z "$_pidfile" -o -z "$_procname" ]; then
261                 err 3 'USAGE: check_pidfile pidfile procname [interpreter]'
262         fi
263         if [ ! -f $_pidfile ]; then
264                 debug "pid file ($_pidfile): not readable."
265                 return
266         fi
267         read _pid _junk < $_pidfile
268         if [ -z "$_pid" ]; then
269                 debug "pid file ($_pidfile): no pid in file."
270                 return
271         fi
272         _find_processes $_procname ${_interpreter:-.} '-p '"$_pid"
273 }
274
275 #
276 # check_process procname [interpreter]
277 #       Ensures that a process (or processes) named procname is running.
278 #       Prints a list of matching PIDs.
279 #       interpreter is optional; see _find_processes() for details.
280 #
281 check_process()
282 {
283         _procname=$1
284         _interpreter=$2
285         if [ -z "$_procname" ]; then
286                 err 3 'USAGE: check_process procname [interpreter]'
287         fi
288         _find_processes $_procname ${_interpreter:-.} '-ax'
289 }
290
291 #
292 # _find_processes procname interpreter psargs
293 #       Search for procname in the output of ps generated by psargs.
294 #       Prints the PIDs of any matching processes, space separated.
295 #
296 #       If interpreter == ".", check the following variations of procname
297 #       against the first word of each command:
298 #               procname
299 #               `basename procname`
300 #               `basename procname` + ":"
301 #               "(" + `basename procname` + ")"
302 #               "[" + `basename procname` + "]"
303 #
304 #       If interpreter != ".", read the first line of procname, remove the
305 #       leading #!, normalise whitespace, append procname, and attempt to
306 #       match that against each command, either as is, or with extra words
307 #       at the end.  As an alternative, to deal with interpreted daemons
308 #       using perl, the basename of the interpreter plus a colon is also
309 #       tried as the prefix to procname.
310 #
311 _find_processes()
312 {
313         if [ $# -ne 3 ]; then
314                 err 3 'USAGE: _find_processes procname interpreter psargs'
315         fi
316         _procname=$1
317         _interpreter=$2
318         _psargs=$3
319
320         _pref=
321         if [ $_interpreter != "." ]; then       # an interpreted script
322                 _script="${_chroot}${_chroot:+/}$_procname"
323                 if [ -r "$_script" ]; then
324                         read _interp < $_script # read interpreter name
325                         case "$_interp" in
326                         \#!*)
327                                 _interp=${_interp#\#!}  # strip #!
328                                 set -- $_interp
329                                 case $1 in
330                                 */bin/env)
331                                         shift   # drop env to get real name
332                                         ;;
333                                 esac
334                                 if [ $_interpreter != $1 ]; then
335                                         warn "\$command_interpreter $_interpreter != $1"
336                                 fi
337                                 ;;
338                         *)
339                                 warn "no shebang line in $_script"
340                                 set -- $_interpreter
341                                 ;;
342                         esac
343                 else
344                         warn "cannot read shebang line from $_script"
345                         set -- $_interpreter
346                 fi
347                 _interp="$* $_procname"         # cleanup spaces, add _procname
348                 _interpbn=${1##*/}
349                 _fp_args='_argv'
350                 _fp_match='case "$_argv" in
351                     ${_interp}|"${_interp} "*|"[${_interpbn}]"|"${_interpbn}: ${_procname}"*)'
352         else                                    # a normal daemon
353                 _procnamebn=${_procname##*/}
354                 _fp_args='_arg0 _argv'
355                 _fp_match='case "$_arg0" in
356                     $_procname|$_procnamebn|${_procnamebn}:|"(${_procnamebn})"|"[${_procnamebn}]")'
357         fi
358
359         _proccheck="\
360                 $PS 2>/dev/null -o pid= -o jid= -o command= $_psargs"' |
361                 while read _npid _jid '"$_fp_args"'; do
362                         '"$_fp_match"'
363                                 if [ "$JID" -eq "$_jid" ];
364                                 then echo -n "$_pref$_npid";
365                                 _pref=" ";
366                                 fi
367                                 ;;
368                         esac
369                 done'
370
371 #       debug "in _find_processes: proccheck is ($_proccheck)."
372         eval $_proccheck
373 }
374
375 # sort_lite [-b] [-n] [-k POS] [-t SEP]
376 #       A lite version of sort(1) (supporting a few options) that can be used
377 #       before the real sort(1) is available (e.g., in scripts that run prior
378 #       to mountcritremote). Requires only shell built-in functionality.
379 #
380 sort_lite()
381 {
382         local funcname=sort_lite
383         local sort_sep="$IFS" sort_ignore_leading_space=
384         local sort_field=0 sort_strict_fields= sort_numeric=
385         local nitems=0 skip_leading=0 trim=
386
387         local OPTIND flag
388         while getopts bnk:t: flag; do
389                 case "$flag" in
390                 b) sort_ignore_leading_space=1 ;;
391                 n) sort_numeric=1 sort_ignore_leading_space=1 ;;
392                 k) sort_field="${OPTARG%%,*}" ;; # only up to first comma
393                         # NB: Unlike sort(1) only one POS allowed
394                 t) sort_sep="$OPTARG"
395                    if [ ${#sort_sep} -gt 1 ]; then
396                         echo "$funcname: multi-character tab \`$sort_sep'" >&2
397                         return 1
398                    fi
399                    sort_strict_fields=1
400                    ;;
401                 \?) return 1 ;;
402                 esac
403         done
404         shift $(( $OPTIND - 1 ))
405
406         # Create transformation pattern to trim leading text if desired
407         case "$sort_field" in
408         ""|[!0-9]*|*[!0-9.]*)
409                 echo "$funcname: invalid sort field \`$sort_field'" >&2
410                 return 1
411                 ;;
412         *.*)
413                 skip_leading=${sort_field#*.} sort_field=${sort_field%%.*}
414                 while [ ${skip_leading:-0} -gt 1 ] 2> /dev/null; do
415                         trim="$trim?" skip_leading=$(( $skip_leading - 1 ))
416                 done
417         esac
418
419         # Copy input to series of local numbered variables
420         # NB: IFS of NULL preserves leading whitespace
421         local LINE
422         while IFS= read -r LINE || [ "$LINE" ]; do
423                 nitems=$(( $nitems + 1 ))
424                 local src_$nitems="$LINE"
425         done
426
427         #
428         # Sort numbered locals using insertion sort
429         #
430         local curitem curitem_orig curitem_mod curitem_haskey
431         local dest dest_orig dest_mod dest_haskey
432         local d gt n
433         local i=1 
434         while [ $i -le $nitems ]; do
435                 curitem_haskey=1 # Assume sort field (-k POS) exists
436                 eval curitem=\"\$src_$i\"
437                 curitem_mod="$curitem" # for modified comparison
438                 curitem_orig="$curitem" # for original comparison
439
440                 # Trim leading whitespace if desired
441                 if [ "$sort_ignore_leading_space" ]; then
442                         while case "$curitem_orig" in
443                                 [$IFS]*) : ;; *) false; esac
444                         do
445                                 curitem_orig="${curitem_orig#?}"
446                         done
447                         curitem_mod="$curitem_orig"
448                 fi
449
450                 # Shift modified comparison value if sort field (-k POS) is > 1
451                 n=$sort_field
452                 while [ $n -gt 1 ]; do
453                         case "$curitem_mod" in
454                         *[$sort_sep]*)
455                                 # Cut text up-to (and incl.) first separator
456                                 curitem_mod="${curitem_mod#*[$sort_sep]}"
457
458                                 # Skip NULLs unless strict field splitting
459                                 [ "$sort_strict_fields" ] ||
460                                         [ "${curitem_mod%%[$sort_sep]*}" ] ||
461                                         [ $n -eq 2 ] ||
462                                         continue
463                                 ;;
464                         *)
465                                 # Asked for a field that doesn't exist
466                                 curitem_haskey= break
467                         esac
468                         n=$(( $n - 1 ))
469                 done
470
471                 # Trim trailing words if sort field >= 1
472                 [ $sort_field -ge 1 -a "$sort_numeric" ] &&
473                         curitem_mod="${curitem_mod%%[$sort_sep]*}"
474
475                 # Apply optional trim (-k POS.TRIM) to cut leading characters
476                 curitem_mod="${curitem_mod#$trim}"
477
478                 # Determine the type of modified comparison to use initially
479                 # NB: Prefer numerical if requested but fallback to standard
480                 case "$curitem_mod" in
481                 ""|[!0-9]*) # NULL or begins with non-number
482                         gt=">"
483                         [ "$sort_numeric" ] && curitem_mod=0
484                         ;;
485                 *)
486                         if [ "$sort_numeric" ]; then
487                                 gt="-gt"
488                                 curitem_mod="${curitem_mod%%[!0-9]*}"
489                                         # NB: trailing non-digits removed
490                                         # otherwise numeric comparison fails
491                         else
492                                 gt=">"
493                         fi
494                 esac
495
496                 # If first time through, short-circuit below position-search
497                 if [ $i -le 1 ]; then
498                         d=0
499                 else
500                         d=1
501                 fi
502
503                 #
504                 # Find appropriate element position
505                 #
506                 while [ $d -gt 0 ]
507                 do
508                         dest_haskey=$curitem_haskey
509                         eval dest=\"\$dest_$d\"
510                         dest_mod="$dest" # for modified comparison
511                         dest_orig="$dest" # for original comparison
512
513                         # Trim leading whitespace if desired
514                         if [ "$sort_ignore_leading_space" ]; then
515                                 while case "$dest_orig" in
516                                         [$IFS]*) : ;; *) false; esac
517                                 do
518                                         dest_orig="${dest_orig#?}"
519                                 done
520                                 dest_mod="$dest_orig"
521                         fi
522
523                         # Shift modified value if sort field (-k POS) is > 1
524                         n=$sort_field
525                         while [ $n -gt 1 ]; do
526                                 case "$dest_mod" in
527                                 *[$sort_sep]*)
528                                         # Cut text up-to (and incl.) 1st sep
529                                         dest_mod="${dest_mod#*[$sort_sep]}"
530
531                                         # Skip NULLs unless strict fields
532                                         [ "$sort_strict_fields" ] ||
533                                             [ "${dest_mod%%[$sort_sep]*}" ] ||
534                                             [ $n -eq 2 ] ||
535                                             continue
536                                         ;;
537                                 *)
538                                         # Asked for a field that doesn't exist
539                                         dest_haskey= break
540                                 esac
541                                 n=$(( $n - 1 ))
542                         done
543
544                         # Trim trailing words if sort field >= 1
545                         [ $sort_field -ge 1 -a "$sort_numeric" ] &&
546                                 dest_mod="${dest_mod%%[$sort_sep]*}"
547
548                         # Apply optional trim (-k POS.TRIM), cut leading chars
549                         dest_mod="${dest_mod#$trim}"
550
551                         # Determine type of modified comparison to use
552                         # NB: Prefer numerical if requested, fallback to std
553                         case "$dest_mod" in
554                         ""|[!0-9]*) # NULL or begins with non-number
555                                 gt=">"
556                                 [ "$sort_numeric" ] && dest_mod=0
557                                 ;;
558                         *)
559                                 if [ "$sort_numeric" ]; then
560                                         gt="-gt"
561                                         dest_mod="${dest_mod%%[!0-9]*}"
562                                                 # NB: kill trailing non-digits
563                                                 # for numeric comparison safety
564                                 else
565                                         gt=">"
566                                 fi
567                         esac
568
569                         # Break if we've found the proper element position
570                         if [ "$curitem_haskey" -a "$dest_haskey" ]; then
571                                 if [ "$dest_mod" = "$curitem_mod" ]; then
572                                         [ "$dest_orig" ">" "$curitem_orig" ] &&
573                                                 break
574                                 elif [ "$dest_mod" $gt "$curitem_mod" ] \
575                                         2> /dev/null
576                                 then
577                                         break
578                                 fi
579                         else
580                                 [ "$dest_orig" ">" "$curitem_orig" ] && break
581                         fi
582
583                         # Break if we've hit the end
584                         [ $d -ge $i ] && break
585
586                         d=$(( $d + 1 ))
587                 done
588
589                 # Shift remaining positions forward, making room for new item
590                 n=$i
591                 while [ $n -ge $d ]; do
592                         # Shift destination item forward one placement
593                         eval dest_$(( $n + 1 ))=\"\$dest_$n\"
594                         n=$(( $n - 1 ))
595                 done
596
597                 # Place the element
598                 if [ $i -eq 1 ]; then
599                         local dest_1="$curitem"
600                 else
601                         local dest_$d="$curitem"
602                 fi
603
604                 i=$(( $i + 1 ))
605         done
606
607         # Print sorted results
608         d=1
609         while [ $d -le $nitems ]; do
610                 eval echo \"\$dest_$d\"
611                 d=$(( $d + 1 ))
612         done
613 }
614
615 #
616 # wait_for_pids pid [pid ...]
617 #       spins until none of the pids exist
618 #
619 wait_for_pids()
620 {
621         local _list _prefix _nlist _j
622
623         _list="$@"
624         if [ -z "$_list" ]; then
625                 return
626         fi
627         _prefix=
628         while true; do
629                 _nlist="";
630                 for _j in $_list; do
631                         if kill -0 $_j 2>/dev/null; then
632                                 _nlist="${_nlist}${_nlist:+ }$_j"
633                                 [ -n "$_prefix" ] && sleep 1
634                         fi
635                 done
636                 if [ -z "$_nlist" ]; then
637                         break
638                 fi
639                 _list=$_nlist
640                 echo -n ${_prefix:-"Waiting for PIDS: "}$_list
641                 _prefix=", "
642                 pwait $_list 2>/dev/null
643         done
644         if [ -n "$_prefix" ]; then
645                 echo "."
646         fi
647 }
648
649 #
650 # get_pidfile_from_conf string file
651 #
652 #       Takes a string to search for in the specified file.
653 #       Ignores lines with traditional comment characters.
654 #
655 # Example:
656 #
657 # if get_pidfile_from_conf string file; then
658 #       pidfile="$_pidfile_from_conf"
659 # else
660 #       pidfile='appropriate default'
661 # fi
662 #
663 get_pidfile_from_conf()
664 {
665         if [ -z "$1" -o -z "$2" ]; then
666                 err 3 "USAGE: get_pidfile_from_conf string file ($name)"
667         fi
668
669         local string file line
670
671         string="$1" ; file="$2"
672
673         if [ ! -s "$file" ]; then
674                 err 3 "get_pidfile_from_conf: $file does not exist ($name)"
675         fi
676
677         while read line; do
678                 case "$line" in
679                 *[#\;]*${string}*)      continue ;;
680                 *${string}*)            break ;;
681                 esac
682         done < $file
683
684         if [ -n "$line" ]; then
685                 line=${line#*/}
686                 _pidfile_from_conf="/${line%%[\"\;]*}"
687         else
688                 return 1
689         fi
690 }
691
692 #
693 # check_startmsgs
694 #       If rc_quiet is set (usually as a result of using faststart at
695 #       boot time) check if rc_startmsgs is enabled.
696 #
697 check_startmsgs()
698 {
699         if [ -n "$rc_quiet" ]; then
700                 checkyesno rc_startmsgs
701         else
702                 return 0
703         fi
704 }
705
706 #
707 # run_rc_command argument
708 #       Search for argument in the list of supported commands, which is:
709 #               "start stop restart rcvar status poll ${extra_commands}"
710 #       If there's a match, run ${argument}_cmd or the default method
711 #       (see below).
712 #
713 #       If argument has a given prefix, then change the operation as follows:
714 #               Prefix  Operation
715 #               ------  ---------
716 #               fast    Skip the pid check, and set rc_fast=yes, rc_quiet=yes
717 #               force   Set ${rcvar} to YES, and set rc_force=yes
718 #               one     Set ${rcvar} to YES
719 #               quiet   Don't output some diagnostics, and set rc_quiet=yes
720 #
721 #       The following globals are used:
722 #
723 #       Name            Needed  Purpose
724 #       ----            ------  -------
725 #       name            y       Name of script.
726 #
727 #       command         n       Full path to command.
728 #                               Not needed if ${rc_arg}_cmd is set for
729 #                               each keyword.
730 #
731 #       command_args    n       Optional args/shell directives for command.
732 #
733 #       command_interpreter n   If not empty, command is interpreted, so
734 #                               call check_{pidfile,process}() appropriately.
735 #
736 #       desc            n       Description of script.
737 #
738 #       extra_commands  n       List of extra commands supported.
739 #
740 #       pidfile         n       If set, use check_pidfile $pidfile $command,
741 #                               otherwise use check_process $command.
742 #                               In either case, only check if $command is set.
743 #
744 #       procname        n       Process name to check for instead of $command.
745 #
746 #       rcvar           n       This is checked with checkyesno to determine
747 #                               if the action should be run.
748 #
749 #       ${name}_program n       Full path to command.
750 #                               Meant to be used in /etc/rc.conf to override
751 #                               ${command}.
752 #
753 #       ${name}_chroot  n       Directory to chroot to before running ${command}
754 #                               Requires /usr to be mounted.
755 #
756 #       ${name}_chdir   n       Directory to cd to before running ${command}
757 #                               (if not using ${name}_chroot).
758 #
759 #       ${name}_flags   n       Arguments to call ${command} with.
760 #                               NOTE:   $flags from the parent environment
761 #                                       can be used to override this.
762 #
763 #       ${name}_env     n       Environment variables to run ${command} with.
764 #
765 #       ${name}_env_file n      File to source variables to run ${command} with.
766 #
767 #       ${name}_fib     n       Routing table number to run ${command} with.
768 #
769 #       ${name}_nice    n       Nice level to run ${command} at.
770 #
771 #       ${name}_oomprotect n    Don't kill ${command} when swap space is exhausted.
772 #
773 #       ${name}_user    n       User to run ${command} as, using su(1) if not
774 #                               using ${name}_chroot.
775 #                               Requires /usr to be mounted.
776 #
777 #       ${name}_group   n       Group to run chrooted ${command} as.
778 #                               Requires /usr to be mounted.
779 #
780 #       ${name}_groups  n       Comma separated list of supplementary groups
781 #                               to run the chrooted ${command} with.
782 #                               Requires /usr to be mounted.
783 #
784 #       ${name}_prepend n       Command added before ${command}.
785 #
786 #       ${name}_login_class n   Login class to use, else "daemon".
787 #
788 #       ${name}_limits  n       limits(1) to apply to ${command}.
789 #
790 #       ${rc_arg}_cmd   n       If set, use this as the method when invoked;
791 #                               Otherwise, use default command (see below)
792 #
793 #       ${rc_arg}_precmd n      If set, run just before performing the
794 #                               ${rc_arg}_cmd method in the default
795 #                               operation (i.e, after checking for required
796 #                               bits and process (non)existence).
797 #                               If this completes with a non-zero exit code,
798 #                               don't run ${rc_arg}_cmd.
799 #
800 #       ${rc_arg}_postcmd n     If set, run just after performing the
801 #                               ${rc_arg}_cmd method, if that method
802 #                               returned a zero exit code.
803 #
804 #       required_dirs   n       If set, check for the existence of the given
805 #                               directories before running a (re)start command.
806 #
807 #       required_files  n       If set, check for the readability of the given
808 #                               files before running a (re)start command.
809 #
810 #       required_modules n      If set, ensure the given kernel modules are
811 #                               loaded before running a (re)start command.
812 #                               The check and possible loads are actually
813 #                               done after start_precmd so that the modules
814 #                               aren't loaded in vain, should the precmd
815 #                               return a non-zero status to indicate a error.
816 #                               If a word in the list looks like "foo:bar",
817 #                               "foo" is the KLD file name and "bar" is the
818 #                               module name.  If a word looks like "foo~bar",
819 #                               "foo" is the KLD file name and "bar" is a
820 #                               egrep(1) pattern matching the module name.
821 #                               Otherwise the module name is assumed to be
822 #                               the same as the KLD file name, which is most
823 #                               common.  See load_kld().
824 #
825 #       required_vars   n       If set, perform checkyesno on each of the
826 #                               listed variables before running the default
827 #                               (re)start command.
828 #
829 #       Default behaviour for a given argument, if no override method is
830 #       provided:
831 #
832 #       Argument        Default behaviour
833 #       --------        -----------------
834 #       start           if !running && checkyesno ${rcvar}
835 #                               ${command}
836 #
837 #       stop            if ${pidfile}
838 #                               rc_pid=$(check_pidfile $pidfile $command)
839 #                       else
840 #                               rc_pid=$(check_process $command)
841 #                       kill $sig_stop $rc_pid
842 #                       wait_for_pids $rc_pid
843 #                       ($sig_stop defaults to TERM.)
844 #
845 #       reload          Similar to stop, except use $sig_reload instead,
846 #                       and doesn't wait_for_pids.
847 #                       $sig_reload defaults to HUP.
848 #                       Note that `reload' isn't provided by default,
849 #                       it should be enabled via $extra_commands.
850 #
851 #       restart         Run `stop' then `start'.
852 #
853 #       status          Show if ${command} is running, etc.
854 #
855 #       poll            Wait for ${command} to exit.
856 #
857 #       rcvar           Display what rc.conf variable is used (if any).
858 #
859 #       enabled         Return true if the service is enabled.
860 #
861 #       describe        Show the service's description
862 #
863 #       extracommands   Show the service's extra commands
864 #
865 #       Variables available to methods, and after run_rc_command() has
866 #       completed:
867 #
868 #       Variable        Purpose
869 #       --------        -------
870 #       rc_arg          Argument to command, after fast/force/one processing
871 #                       performed
872 #
873 #       rc_flags        Flags to start the default command with.
874 #                       Defaults to ${name}_flags, unless overridden
875 #                       by $flags from the environment.
876 #                       This variable may be changed by the precmd method.
877 #
878 #       rc_service      Path to the service being executed, in case the service
879 #                       needs to re-invoke itself.
880 #
881 #       rc_pid          PID of command (if appropriate)
882 #
883 #       rc_fast         Not empty if "fast" was provided (q.v.)
884 #
885 #       rc_force        Not empty if "force" was provided (q.v.)
886 #
887 #       rc_quiet        Not empty if "quiet" was provided
888 #
889 #
890 run_rc_command()
891 {
892         _return=0
893         rc_arg=$1
894         if [ -z "$name" ]; then
895                 err 3 'run_rc_command: $name is not set.'
896         fi
897
898         # Don't repeat the first argument when passing additional command-
899         # line arguments to the command subroutines.
900         #
901         shift 1
902         rc_extra_args="$*"
903
904         _rc_prefix=
905         case "$rc_arg" in
906         fast*)                          # "fast" prefix; don't check pid
907                 rc_arg=${rc_arg#fast}
908                 rc_fast=yes
909                 rc_quiet=yes
910                 ;;
911         force*)                         # "force" prefix; always run
912                 rc_force=yes
913                 _rc_prefix=force
914                 rc_arg=${rc_arg#${_rc_prefix}}
915                 if [ -n "${rcvar}" ]; then
916                         eval ${rcvar}=YES
917                 fi
918                 ;;
919         one*)                           # "one" prefix; set ${rcvar}=yes
920                 _rc_prefix=one
921                 rc_arg=${rc_arg#${_rc_prefix}}
922                 if [ -n "${rcvar}" ]; then
923                         eval ${rcvar}=YES
924                 fi
925                 ;;
926         quiet*)                         # "quiet" prefix; omit some messages
927                 _rc_prefix=quiet
928                 rc_arg=${rc_arg#${_rc_prefix}}
929                 rc_quiet=yes
930                 ;;
931         esac
932
933         eval _override_command=\$${name}_program
934         command=${_override_command:-$command}
935
936         _keywords="start stop restart rcvar enable disable delete enabled describe extracommands $extra_commands"
937         rc_pid=
938         _pidcmd=
939         _procname=${procname:-${command}}
940
941                                         # setup pid check command
942         if [ -n "$_procname" ]; then
943                 if [ -n "$pidfile" ]; then
944                         _pidcmd='rc_pid=$(check_pidfile '"$pidfile $_procname $command_interpreter"')'
945                 else
946                         _pidcmd='rc_pid=$(check_process '"$_procname $command_interpreter"')'
947                 fi
948                 _keywords="${_keywords} status poll"
949         fi
950
951         if [ -z "$rc_arg" ]; then
952                 rc_usage $_keywords
953         fi
954
955         if [ "$rc_arg" = "enabled" ] ; then
956                 checkyesno ${rcvar}
957                 return $?
958         fi
959
960         if [ -n "$flags" ]; then        # allow override from environment
961                 rc_flags=$flags
962         else
963                 eval rc_flags=\$${name}_flags
964         fi
965         eval _chdir=\$${name}_chdir     _chroot=\$${name}_chroot \
966             _nice=\$${name}_nice        _user=\$${name}_user \
967             _group=\$${name}_group      _groups=\$${name}_groups \
968             _fib=\$${name}_fib          _env=\$${name}_env \
969             _prepend=\$${name}_prepend  _login_class=\${${name}_login_class:-daemon} \
970             _limits=\$${name}_limits    _oomprotect=\$${name}_oomprotect \
971             _env_file=\$${name}_env_file
972
973         if [ -n "$_env_file" ] && [ -r "${_env_file}" ]; then   # load env from file
974                 set -a
975                 . $_env_file
976                 set +a
977         fi
978
979         if [ -n "$_user" ]; then        # unset $_user if running as that user
980                 if [ "$_user" = "$(eval $IDCMD)" ]; then
981                         unset _user
982                 fi
983         fi
984
985         [ -z "$autoboot" ] && eval $_pidcmd     # determine the pid if necessary
986
987         for _elem in $_keywords; do
988                 if [ "$_elem" != "$rc_arg" ]; then
989                         continue
990                 fi
991                                         # if ${rcvar} is set, $1 is not "rcvar", "describe",
992                                         # "enable" or "delete", and ${rc_pid} is not set, run:
993                                         #       checkyesno ${rcvar}
994                                         # and return if that failed
995                                         #
996                 if [ -n "${rcvar}" -a "$rc_arg" != "rcvar" -a "$rc_arg" != "stop" \
997                     -a "$rc_arg" != "delete" -a "$rc_arg" != "enable" \
998                     -a "$rc_arg" != "describe" ] ||
999                     [ -n "${rcvar}" -a "$rc_arg" = "stop" -a -z "${rc_pid}" ]; then
1000                         if ! checkyesno ${rcvar}; then
1001                                 if [ -n "${rc_quiet}" ]; then
1002                                         return 0
1003                                 fi
1004                                 echo -n "Cannot '${rc_arg}' $name. Set ${rcvar} to "
1005                                 echo -n "YES in /etc/rc.conf or use 'one${rc_arg}' "
1006                                 echo "instead of '${rc_arg}'."
1007                                 return 0
1008                         fi
1009                 fi
1010
1011                 if [ $rc_arg = "start" -a -z "$rc_fast" -a -n "$rc_pid" ]; then
1012                         if [ -z "$rc_quiet" ]; then
1013                                 echo 1>&2 "${name} already running? " \
1014                                     "(pid=$rc_pid)."
1015                         fi
1016                         return 1
1017                 fi
1018
1019                                         # if there's a custom ${XXX_cmd},
1020                                         # run that instead of the default
1021                                         #
1022                 eval _cmd=\$${rc_arg}_cmd \
1023                      _precmd=\$${rc_arg}_precmd \
1024                      _postcmd=\$${rc_arg}_postcmd
1025
1026                 if [ -n "$_cmd" ]; then
1027                         _run_rc_precmd || return 1
1028                         _run_rc_doit "$_cmd $rc_extra_args" || return 1
1029                         _run_rc_postcmd
1030                         return $_return
1031                 fi
1032
1033                 case "$rc_arg" in       # default operations...
1034
1035                 describe)
1036                         if [ -n "$desc" ]; then
1037                                 echo "$desc"
1038                         fi
1039                         ;;
1040         
1041                 extracommands)
1042                         echo "$extra_commands"
1043                         ;;
1044
1045                 enable)
1046                         _out=$(/usr/sbin/sysrc -vs "$name" "$rcvar=YES") &&
1047                                 echo "$name enabled in ${_out%%:*}"     
1048                         ;;
1049
1050                 disable)
1051                         _out=$(/usr/sbin/sysrc -vs "$name" "$rcvar=NO") &&
1052                                 echo "$name disabled in ${_out%%:*}"    
1053                         ;;
1054
1055                 delete)
1056                         _files=
1057                         for _file in $(sysrc -lEs "$name"); do
1058                                 _out=$(sysrc -Fif $_file "$rcvar") && _files="$_files $_file"
1059                         done
1060                         /usr/sbin/sysrc -x "$rcvar" && echo "$rcvar deleted in ${_files# }"
1061                                 # delete file in rc.conf.d if desired and empty.
1062                         checkyesno service_delete_empty || _files=
1063                         for _file in $_files; do
1064                                 [ "$_file" = "${_file#*/rc.conf.d/}" ] && continue
1065                                 [ $(/usr/bin/stat -f%z $_file) -gt 0 ] && continue
1066                                 /bin/rm "$_file" && echo "Empty file $_file removed"
1067                         done
1068                         ;;
1069
1070                 status)
1071                         _run_rc_precmd || return 1
1072                         if [ -n "$rc_pid" ]; then
1073                                 echo "${name} is running as pid $rc_pid."
1074                         else
1075                                 echo "${name} is not running."
1076                                 return 1
1077                         fi
1078                         _run_rc_postcmd
1079                         ;;
1080
1081                 start)
1082                         if [ ! -x "${_chroot}${_chroot:+/}${command}" ]; then
1083                                 warn "run_rc_command: cannot run $command"
1084                                 return 1
1085                         fi
1086
1087                         if ! _run_rc_precmd; then
1088                                 warn "failed precmd routine for ${name}"
1089                                 return 1
1090                         fi
1091
1092                                         # setup the full command to run
1093                                         #
1094                         check_startmsgs && echo "Starting ${name}."
1095                         if [ -n "$_chroot" ]; then
1096                                 _cd=
1097                                 _doit="\
1098 ${_nice:+nice -n $_nice }\
1099 ${_fib:+setfib -F $_fib }\
1100 ${_env:+env $_env }\
1101 chroot ${_user:+-u $_user }${_group:+-g $_group }${_groups:+-G $_groups }\
1102 $_chroot $command $rc_flags $command_args"
1103                         else
1104                                 _cd="${_chdir:+cd $_chdir && }"
1105                                 _doit="\
1106 ${_fib:+setfib -F $_fib }\
1107 ${_env:+env $_env }\
1108 $command $rc_flags $command_args"
1109                                 if [ -n "$_user" ]; then
1110                                     _doit="su -m $_user -c 'sh -c \"$_doit\"'"
1111                                 fi
1112                                 if [ -n "$_nice" ]; then
1113                                         if [ -z "$_user" ]; then
1114                                                 _doit="sh -c \"$_doit\""
1115                                         fi
1116                                         _doit="nice -n $_nice $_doit"
1117                                 fi
1118                                 if [ -n "$_prepend" ]; then
1119                                         _doit="$_prepend $_doit"
1120                                 fi
1121                         fi
1122
1123                                         # Prepend default limits
1124                         _doit="$_cd limits -C $_login_class $_limits $_doit"
1125
1126                                         # run the full command
1127                                         #
1128                         if ! _run_rc_doit "$_doit"; then
1129                                 warn "failed to start ${name}"
1130                                 return 1
1131                         fi
1132
1133                                         # finally, run postcmd
1134                                         #
1135                         _run_rc_postcmd
1136                         ;;
1137
1138                 stop)
1139                         if [ -z "$rc_pid" ]; then
1140                                 [ -n "$rc_fast" ] && return 0
1141                                 _run_rc_notrunning
1142                                 return 1
1143                         fi
1144
1145                         _run_rc_precmd || return 1
1146
1147                                         # send the signal to stop
1148                                         #
1149                         echo "Stopping ${name}."
1150                         _doit=$(_run_rc_killcmd "${sig_stop:-TERM}")
1151                         _run_rc_doit "$_doit" || return 1
1152
1153                                         # wait for the command to exit,
1154                                         # and run postcmd.
1155                         wait_for_pids $rc_pid
1156
1157                         _run_rc_postcmd
1158                         ;;
1159
1160                 reload)
1161                         if [ -z "$rc_pid" ]; then
1162                                 _run_rc_notrunning
1163                                 return 1
1164                         fi
1165
1166                         _run_rc_precmd || return 1
1167
1168                         _doit=$(_run_rc_killcmd "${sig_reload:-HUP}")
1169                         _run_rc_doit "$_doit" || return 1
1170
1171                         _run_rc_postcmd
1172                         ;;
1173
1174                 restart)
1175                                         # prevent restart being called more
1176                                         # than once by any given script
1177                                         #
1178                         if ${_rc_restart_done:-false}; then
1179                                 return 0
1180                         fi
1181                         _rc_restart_done=true
1182
1183                         _run_rc_precmd || return 1
1184
1185                         # run those in a subshell to keep global variables
1186                         ( run_rc_command ${_rc_prefix}stop $rc_extra_args )
1187                         ( run_rc_command ${_rc_prefix}start $rc_extra_args )
1188                         _return=$?
1189                         [ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
1190
1191                         _run_rc_postcmd
1192                         ;;
1193
1194                 poll)
1195                         _run_rc_precmd || return 1
1196                         if [ -n "$rc_pid" ]; then
1197                                 wait_for_pids $rc_pid
1198                         fi
1199                         _run_rc_postcmd
1200                         ;;
1201
1202                 rcvar)
1203                         echo -n "# $name"
1204                         if [ -n "$desc" ]; then
1205                                 echo " : $desc"
1206                         else
1207                                 echo ""
1208                         fi
1209                         echo "#"
1210                         # Get unique vars in $rcvar $rcvars
1211                         for _v in $rcvar $rcvars; do
1212                                 case $v in
1213                                 $_v\ *|\ *$_v|*\ $_v\ *) ;;
1214                                 *)      v="${v# } $_v" ;;
1215                                 esac
1216                         done
1217
1218                         # Display variables.
1219                         for _v in $v; do
1220                                 if [ -z "$_v" ]; then
1221                                         continue
1222                                 fi
1223
1224                                 eval _desc=\$${_v}_desc
1225                                 eval _defval=\$${_v}_defval
1226                                 _h="-"
1227
1228                                 eval echo \"$_v=\\\"\$$_v\\\"\"
1229                                 # decode multiple lines of _desc
1230                                 while [ -n "$_desc" ]; do
1231                                         case $_desc in
1232                                         *^^*)
1233                                                 echo "# $_h ${_desc%%^^*}"
1234                                                 _desc=${_desc#*^^}
1235                                                 _h=" "
1236                                                 ;;
1237                                         *)
1238                                                 echo "# $_h ${_desc}"
1239                                                 break
1240                                                 ;;
1241                                         esac
1242                                 done
1243                                 echo "#   (default: \"$_defval\")"
1244                         done
1245                         echo ""
1246                         ;;
1247
1248                 *)
1249                         rc_usage $_keywords
1250                         ;;
1251
1252                 esac
1253
1254                 # Apply protect(1) to the PID if ${name}_oomprotect is set.
1255                 case "$rc_arg" in
1256                 start)
1257                         # We cannot use protect(1) inside jails.
1258                         if [ -n "$_oomprotect" ] && [ -f "${PROTECT}" ] &&
1259                             [ "$(sysctl -n security.jail.jailed)" -eq 0 ]; then
1260                                 pid=$(check_process $command)
1261                                 case $_oomprotect in
1262                                 [Aa][Ll][Ll])
1263                                         ${PROTECT} -i -p ${pid}
1264                                         ;;
1265                                 [Yy][Ee][Ss])
1266                                         ${PROTECT} -p ${pid}
1267                                         ;;
1268                                 esac
1269                         fi      
1270                 ;;
1271                 esac
1272
1273                 return $_return
1274         done
1275
1276         echo 1>&2 "$0: unknown directive '$rc_arg'."
1277         rc_usage $_keywords
1278         # not reached
1279 }
1280
1281 #
1282 # Helper functions for run_rc_command: common code.
1283 # They use such global variables besides the exported rc_* ones:
1284 #
1285 #       name           R/W
1286 #       ------------------
1287 #       _precmd         R
1288 #       _postcmd        R
1289 #       _return         W
1290 #
1291 _run_rc_precmd()
1292 {
1293         check_required_before "$rc_arg" || return 1
1294
1295         if [ -n "$_precmd" ]; then
1296                 debug "run_rc_command: ${rc_arg}_precmd: $_precmd $rc_extra_args"
1297                 eval "$_precmd $rc_extra_args"
1298                 _return=$?
1299
1300                 # If precmd failed and force isn't set, request exit.
1301                 if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
1302                         return 1
1303                 fi
1304         fi
1305
1306         check_required_after "$rc_arg" || return 1
1307
1308         return 0
1309 }
1310
1311 _run_rc_postcmd()
1312 {
1313         if [ -n "$_postcmd" ]; then
1314                 debug "run_rc_command: ${rc_arg}_postcmd: $_postcmd $rc_extra_args"
1315                 eval "$_postcmd $rc_extra_args"
1316                 _return=$?
1317         fi
1318         return 0
1319 }
1320
1321 _run_rc_doit()
1322 {
1323         debug "run_rc_command: doit: $*"
1324         eval "$@"
1325         _return=$?
1326
1327         # If command failed and force isn't set, request exit.
1328         if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
1329                 return 1
1330         fi
1331
1332         return 0
1333 }
1334
1335 _run_rc_notrunning()
1336 {
1337         local _pidmsg
1338
1339         if [ -n "$pidfile" ]; then
1340                 _pidmsg=" (check $pidfile)."
1341         else
1342                 _pidmsg=
1343         fi
1344         echo 1>&2 "${name} not running?${_pidmsg}"
1345 }
1346
1347 _run_rc_killcmd()
1348 {
1349         local _cmd
1350
1351         _cmd="kill -$1 $rc_pid"
1352         if [ -n "$_user" ]; then
1353                 _cmd="su -m ${_user} -c 'sh -c \"${_cmd}\"'"
1354         fi
1355         echo "$_cmd"
1356 }
1357
1358 #
1359 # run_rc_script file arg
1360 #       Start the script `file' with `arg', and correctly handle the
1361 #       return value from the script.
1362 #       If `file' ends with `.sh' and lives in /etc/rc.d, ignore it as it's
1363 #       an old-style startup file.
1364 #       If `file' ends with `.sh' and does not live in /etc/rc.d, it's sourced
1365 #       into the current environment if $rc_fast_and_loose is set; otherwise
1366 #       it is run as a child process.
1367 #       If `file' appears to be a backup or scratch file, ignore it.
1368 #       Otherwise if it is executable run as a child process.
1369 #
1370 run_rc_script()
1371 {
1372         _file=$1
1373         _arg=$2
1374         if [ -z "$_file" -o -z "$_arg" ]; then
1375                 err 3 'USAGE: run_rc_script file arg'
1376         fi
1377
1378         unset   name command command_args command_interpreter \
1379                 extra_commands pidfile procname \
1380                 rcvar rcvars rcvars_obsolete required_dirs required_files \
1381                 required_vars
1382         eval unset ${_arg}_cmd ${_arg}_precmd ${_arg}_postcmd
1383
1384         rc_service="$_file"
1385         case "$_file" in
1386         /etc/rc.d/*.sh)                 # no longer allowed in the base
1387                 warn "Ignoring old-style startup script $_file"
1388                 ;;
1389         *[~#]|*.OLD|*.bak|*.orig|*,v)   # scratch file; skip
1390                 warn "Ignoring scratch file $_file"
1391                 ;;
1392         *)                              # run in subshell
1393                 if [ -x $_file ]; then
1394                         if [ -n "$rc_fast_and_loose" ]; then
1395                                 set $_arg; . $_file
1396                         else
1397                                 ( trap "echo Script $_file interrupted >&2 ; kill -QUIT $$" 3
1398                                   trap "echo Script $_file interrupted >&2 ; exit 1" 2
1399                                   trap "echo Script $_file running >&2" 29
1400                                   set $_arg; . $_file )
1401                         fi
1402                 fi
1403                 ;;
1404         esac
1405 }
1406
1407 #
1408 # load_rc_config [service]
1409 #       Source in the configuration file(s) for a given service.
1410 #       If no service is specified, only the global configuration
1411 #       file(s) will be loaded.
1412 #
1413 load_rc_config()
1414 {
1415         local _name _rcvar_val _var _defval _v _msg _new _d
1416         _name=$1
1417
1418         if ${_rc_conf_loaded:-false}; then
1419                 :
1420         else
1421                 if [ -r /etc/defaults/rc.conf ]; then
1422                         debug "Sourcing /etc/defaults/rc.conf"
1423                         . /etc/defaults/rc.conf
1424                         source_rc_confs
1425                 elif [ -r /etc/rc.conf ]; then
1426                         debug "Sourcing /etc/rc.conf (/etc/defaults/rc.conf doesn't exist)."
1427                         . /etc/rc.conf
1428                 fi
1429                 _rc_conf_loaded=true
1430         fi
1431
1432         # If a service name was specified, attempt to load
1433         # service-specific configuration
1434         if [ -n "$_name" ] ; then
1435                 for _d in /etc ${local_startup}; do
1436                         _d=${_d%/rc.d}
1437                         if [ -f ${_d}/rc.conf.d/"$_name" ]; then
1438                                 debug "Sourcing ${_d}/rc.conf.d/$_name"
1439                                 . ${_d}/rc.conf.d/"$_name"
1440                         elif [ -d ${_d}/rc.conf.d/"$_name" ] ; then
1441                                 local _rc
1442                                 for _rc in ${_d}/rc.conf.d/"$_name"/* ; do
1443                                         if [ -f "$_rc" ] ; then
1444                                                 debug "Sourcing $_rc"
1445                                                 . "$_rc"
1446                                         fi
1447                                 done
1448                         fi
1449                 done
1450         fi
1451
1452         # Set defaults if defined.
1453         for _var in $rcvar $rcvars; do
1454                 eval _defval=\$${_var}_defval
1455                 if [ -n "$_defval" ]; then
1456                         eval : \${$_var:=\$${_var}_defval}
1457                 fi
1458         done
1459
1460         # check obsolete rc.conf variables
1461         for _var in $rcvars_obsolete; do
1462                 eval _v=\$$_var
1463                 eval _msg=\$${_var}_obsolete_msg
1464                 eval _new=\$${_var}_newvar
1465                 case $_v in
1466                 "")
1467                         ;;
1468                 *)
1469                         if [ -z "$_new" ]; then
1470                                 _msg="Ignored."
1471                         else
1472                                 eval $_new=\"\$$_var\"
1473                                 if [ -z "$_msg" ]; then
1474                                         _msg="Use \$$_new instead."
1475                                 fi
1476                         fi
1477                         warn "\$$_var is obsolete.  $_msg"
1478                         ;;
1479                 esac
1480         done
1481 }
1482
1483 #
1484 # load_rc_config_var name var
1485 #       Read the rc.conf(5) var for name and set in the
1486 #       current shell, using load_rc_config in a subshell to prevent
1487 #       unwanted side effects from other variable assignments.
1488 #
1489 load_rc_config_var()
1490 {
1491         if [ $# -ne 2 ]; then
1492                 err 3 'USAGE: load_rc_config_var name var'
1493         fi
1494         eval $(eval '(
1495                 load_rc_config '$1' >/dev/null;
1496                 if [ -n "${'$2'}" -o "${'$2'-UNSET}" != "UNSET" ]; then
1497                         echo '$2'=\'\''${'$2'}\'\'';
1498                 fi
1499         )' )
1500 }
1501
1502 #
1503 # rc_usage commands
1504 #       Print a usage string for $0, with `commands' being a list of
1505 #       valid commands.
1506 #
1507 rc_usage()
1508 {
1509         echo -n 1>&2 "Usage: $0 [fast|force|one|quiet]("
1510
1511         _sep=
1512         for _elem; do
1513                 echo -n 1>&2 "$_sep$_elem"
1514                 _sep="|"
1515         done
1516         echo 1>&2 ")"
1517         exit 1
1518 }
1519
1520 #
1521 # err exitval message
1522 #       Display message to stderr and log to the syslog, and exit with exitval.
1523 #
1524 err()
1525 {
1526         exitval=$1
1527         shift
1528
1529         if [ -x /usr/bin/logger ]; then
1530                 logger "$0: ERROR: $*"
1531         fi
1532         echo 1>&2 "$0: ERROR: $*"
1533         exit $exitval
1534 }
1535
1536 #
1537 # warn message
1538 #       Display message to stderr and log to the syslog.
1539 #
1540 warn()
1541 {
1542         if [ -x /usr/bin/logger ]; then
1543                 logger "$0: WARNING: $*"
1544         fi
1545         echo 1>&2 "$0: WARNING: $*"
1546 }
1547
1548 #
1549 # info message
1550 #       Display informational message to stdout and log to syslog.
1551 #
1552 info()
1553 {
1554         case ${rc_info} in
1555         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1556                 if [ -x /usr/bin/logger ]; then
1557                         logger "$0: INFO: $*"
1558                 fi
1559                 echo "$0: INFO: $*"
1560                 ;;
1561         esac
1562 }
1563
1564 #
1565 # debug message
1566 #       If debugging is enabled in rc.conf output message to stderr.
1567 #       BEWARE that you don't call any subroutine that itself calls this
1568 #       function.
1569 #
1570 debug()
1571 {
1572         case ${rc_debug} in
1573         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1574                 if [ -x /usr/bin/logger ]; then
1575                         logger "$0: DEBUG: $*"
1576                 fi
1577                 echo 1>&2 "$0: DEBUG: $*"
1578                 ;;
1579         esac
1580 }
1581
1582 #
1583 # backup_file action file cur backup
1584 #       Make a backup copy of `file' into `cur', and save the previous
1585 #       version of `cur' as `backup'.
1586 #
1587 #       The `action' keyword can be one of the following:
1588 #
1589 #       add             `file' is now being backed up (and is possibly
1590 #                       being reentered into the backups system).  `cur'
1591 #                       is created.
1592 #
1593 #       update          `file' has changed and needs to be backed up.
1594 #                       If `cur' exists, it is copied to `back'
1595 #                       and then `file' is copied to `cur'.
1596 #
1597 #       remove          `file' is no longer being tracked by the backups
1598 #                       system.  `cur' is moved `back'.
1599 #
1600 #
1601 backup_file()
1602 {
1603         _action=$1
1604         _file=$2
1605         _cur=$3
1606         _back=$4
1607
1608         case $_action in
1609         add|update)
1610                 if [ -f $_cur ]; then
1611                         cp -p $_cur $_back
1612                 fi
1613                 cp -p $_file $_cur
1614                 chown root:wheel $_cur
1615                 ;;
1616         remove)
1617                 mv -f $_cur $_back
1618                 ;;
1619         esac
1620 }
1621
1622 # make_symlink src link
1623 #       Make a symbolic link 'link' to src from basedir. If the
1624 #       directory in which link is to be created does not exist
1625 #       a warning will be displayed and an error will be returned.
1626 #       Returns 0 on success, 1 otherwise.
1627 #
1628 make_symlink()
1629 {
1630         local src link linkdir _me
1631         src="$1"
1632         link="$2"
1633         linkdir="`dirname $link`"
1634         _me="make_symlink()"
1635
1636         if [ -z "$src" -o -z "$link" ]; then
1637                 warn "$_me: requires two arguments."
1638                 return 1
1639         fi
1640         if [ ! -d "$linkdir" ]; then
1641                 warn "$_me: the directory $linkdir does not exist."
1642                 return 1
1643         fi
1644         if ! ln -sf $src $link; then
1645                 warn "$_me: unable to make a symbolic link from $link to $src"
1646                 return 1
1647         fi
1648         return 0
1649 }
1650
1651 # devfs_rulesets_from_file file
1652 #       Reads a set of devfs commands from file, and creates
1653 #       the specified rulesets with their rules. Returns non-zero
1654 #       if there was an error.
1655 #
1656 devfs_rulesets_from_file()
1657 {
1658         local file _err _me _opts
1659         file="$1"
1660         _me="devfs_rulesets_from_file"
1661         _err=0
1662
1663         if [ -z "$file" ]; then
1664                 warn "$_me: you must specify a file"
1665                 return 1
1666         fi
1667         if [ ! -e "$file" ]; then
1668                 debug "$_me: no such file ($file)"
1669                 return 0
1670         fi
1671
1672         # Disable globbing so that the rule patterns are not expanded
1673         # by accident with matching filesystem entries.
1674         _opts=$-; set -f
1675
1676         debug "reading rulesets from file ($file)"
1677         { while read line
1678         do
1679                 case $line in
1680                 \#*)
1681                         continue
1682                         ;;
1683                 \[*\]*)
1684                         rulenum=`expr "$line" : "\[.*=\([0-9]*\)\]"`
1685                         if [ -z "$rulenum" ]; then
1686                                 warn "$_me: cannot extract rule number ($line)"
1687                                 _err=1
1688                                 break
1689                         fi
1690                         rulename=`expr "$line" : "\[\(.*\)=[0-9]*\]"`
1691                         if [ -z "$rulename" ]; then
1692                                 warn "$_me: cannot extract rule name ($line)"
1693                                 _err=1
1694                                 break;
1695                         fi
1696                         eval $rulename=\$rulenum
1697                         debug "found ruleset: $rulename=$rulenum"
1698                         if ! /sbin/devfs rule -s $rulenum delset; then
1699                                 _err=1
1700                                 break
1701                         fi
1702                         ;;
1703                 *)
1704                         rulecmd="${line%%"\#*"}"
1705                         # evaluate the command incase it includes
1706                         # other rules
1707                         if [ -n "$rulecmd" ]; then
1708                                 debug "adding rule ($rulecmd)"
1709                                 if ! eval /sbin/devfs rule -s $rulenum $rulecmd
1710                                 then
1711                                         _err=1
1712                                         break
1713                                 fi
1714                         fi
1715                         ;;
1716                 esac
1717                 if [ $_err -ne 0 ]; then
1718                         debug "error in $_me"
1719                         break
1720                 fi
1721         done } < $file
1722         case $_opts in *f*) ;; *) set +f ;; esac
1723         return $_err
1724 }
1725
1726 # devfs_init_rulesets
1727 #       Initializes rulesets from configuration files. Returns
1728 #       non-zero if there was an error.
1729 #
1730 devfs_init_rulesets()
1731 {
1732         local file _me
1733         _me="devfs_init_rulesets"
1734
1735         # Go through this only once
1736         if [ -n "$devfs_rulesets_init" ]; then
1737                 debug "$_me: devfs rulesets already initialized"
1738                 return
1739         fi
1740         for file in $devfs_rulesets; do
1741                 if ! devfs_rulesets_from_file $file; then
1742                         warn "$_me: could not read rules from $file"
1743                         return 1
1744                 fi
1745         done
1746         devfs_rulesets_init=1
1747         debug "$_me: devfs rulesets initialized"
1748         return 0
1749 }
1750
1751 # devfs_set_ruleset ruleset [dir]
1752 #       Sets the default ruleset of dir to ruleset. The ruleset argument
1753 #       must be a ruleset name as specified in devfs.rules(5) file.
1754 #       Returns non-zero if it could not set it successfully.
1755 #
1756 devfs_set_ruleset()
1757 {
1758         local devdir rs _me
1759         [ -n "$1" ] && eval rs=\$$1 || rs=
1760         [ -n "$2" ] && devdir="-m "$2"" || devdir=
1761         _me="devfs_set_ruleset"
1762
1763         if [ -z "$rs" ]; then
1764                 warn "$_me: you must specify a ruleset number"
1765                 return 1
1766         fi
1767         debug "$_me: setting ruleset ($rs) on mount-point (${devdir#-m })"
1768         if ! /sbin/devfs $devdir ruleset $rs; then
1769                 warn "$_me: unable to set ruleset $rs to ${devdir#-m }"
1770                 return 1
1771         fi
1772         return 0
1773 }
1774
1775 # devfs_apply_ruleset ruleset [dir]
1776 #       Apply ruleset number $ruleset to the devfs mountpoint $dir.
1777 #       The ruleset argument must be a ruleset name as specified
1778 #       in a devfs.rules(5) file.  Returns 0 on success or non-zero
1779 #       if it could not apply the ruleset.
1780 #
1781 devfs_apply_ruleset()
1782 {
1783         local devdir rs _me
1784         [ -n "$1" ] && eval rs=\$$1 || rs=
1785         [ -n "$2" ] && devdir="-m "$2"" || devdir=
1786         _me="devfs_apply_ruleset"
1787
1788         if [ -z "$rs" ]; then
1789                 warn "$_me: you must specify a ruleset"
1790                 return 1
1791         fi
1792         debug "$_me: applying ruleset ($rs) to mount-point (${devdir#-m })"
1793         if ! /sbin/devfs $devdir rule -s $rs applyset; then
1794                 warn "$_me: unable to apply ruleset $rs to ${devdir#-m }"
1795                 return 1
1796         fi
1797         return 0
1798 }
1799
1800 # devfs_domount dir [ruleset]
1801 #       Mount devfs on dir. If ruleset is specified it is set
1802 #       on the mount-point. It must also be a ruleset name as specified
1803 #       in a devfs.rules(5) file. Returns 0 on success.
1804 #
1805 devfs_domount()
1806 {
1807         local devdir rs _me
1808         devdir="$1"
1809         [ -n "$2" ] && rs=$2 || rs=
1810         _me="devfs_domount()"
1811
1812         if [ -z "$devdir" ]; then
1813                 warn "$_me: you must specify a mount-point"
1814                 return 1
1815         fi
1816         debug "$_me: mount-point is ($devdir), ruleset is ($rs)"
1817         if ! mount -t devfs dev "$devdir"; then
1818                 warn "$_me: Unable to mount devfs on $devdir"
1819                 return 1
1820         fi
1821         if [ -n "$rs" ]; then
1822                 devfs_init_rulesets
1823                 devfs_set_ruleset $rs $devdir
1824                 devfs -m $devdir rule applyset
1825         fi
1826         return 0
1827 }
1828
1829 # Provide a function for normalizing the mounting of memory
1830 # filesystems.  This should allow the rest of the code here to remain
1831 # as close as possible between 5-current and 4-stable.
1832 #   $1 = size
1833 #   $2 = mount point
1834 #   $3 = (optional) extra mdmfs flags
1835 mount_md()
1836 {
1837         if [ -n "$3" ]; then
1838                 flags="$3"
1839         fi
1840         /sbin/mdmfs $flags -s $1 ${mfs_type} $2
1841 }
1842
1843 # Code common to scripts that need to load a kernel module
1844 # if it isn't in the kernel yet. Syntax:
1845 #   load_kld [-e regex] [-m module] file
1846 # where -e or -m chooses the way to check if the module
1847 # is already loaded:
1848 #   regex is egrep'd in the output from `kldstat -v',
1849 #   module is passed to `kldstat -m'.
1850 # The default way is as though `-m file' were specified.
1851 load_kld()
1852 {
1853         local _loaded _mod _opt _re
1854
1855         while getopts "e:m:" _opt; do
1856                 case "$_opt" in
1857                 e) _re="$OPTARG" ;;
1858                 m) _mod="$OPTARG" ;;
1859                 *) err 3 'USAGE: load_kld [-e regex] [-m module] file' ;;
1860                 esac
1861         done
1862         shift $(($OPTIND - 1))
1863         if [ $# -ne 1 ]; then
1864                 err 3 'USAGE: load_kld [-e regex] [-m module] file'
1865         fi
1866         _mod=${_mod:-$1}
1867         _loaded=false
1868         if [ -n "$_re" ]; then
1869                 if kldstat -v | egrep -q -e "$_re"; then
1870                         _loaded=true
1871                 fi
1872         else
1873                 if kldstat -q -m "$_mod"; then
1874                         _loaded=true
1875                 fi
1876         fi
1877         if ! $_loaded; then
1878                 if ! kldload "$1"; then
1879                         warn "Unable to load kernel module $1"
1880                         return 1
1881                 else
1882                         info "$1 kernel module loaded."
1883                 fi
1884         else
1885                 debug "load_kld: $1 kernel module already loaded."
1886         fi
1887         return 0
1888 }
1889
1890 # ltr str src dst [var]
1891 #       Change every $src in $str to $dst.
1892 #       Useful when /usr is not yet mounted and we cannot use tr(1), sed(1) nor
1893 #       awk(1). If var is non-NULL, set it to the result.
1894 ltr()
1895 {
1896         local _str _src _dst _out _com _var
1897         _str="$1"
1898         _src="$2"
1899         _dst="$3"
1900         _var="$4"
1901         _out=""
1902
1903         local IFS="${_src}"
1904         for _com in ${_str}; do
1905                 if [ -z "${_out}" ]; then
1906                         _out="${_com}"
1907                 else
1908                         _out="${_out}${_dst}${_com}"
1909                 fi
1910         done
1911         if [ -n "${_var}" ]; then
1912                 setvar "${_var}" "${_out}"
1913         else
1914                 echo "${_out}"
1915         fi
1916 }
1917
1918 # Creates a list of providers for GELI encryption.
1919 geli_make_list()
1920 {
1921         local devices devices2
1922         local provider mountpoint type options rest
1923
1924         # Create list of GELI providers from fstab.
1925         while read provider mountpoint type options rest ; do
1926                 case ":${options}" in
1927                 :*noauto*)
1928                         noauto=yes
1929                         ;;
1930                 *)
1931                         noauto=no
1932                         ;;
1933                 esac
1934
1935                 case ":${provider}" in
1936                 :#*)
1937                         continue
1938                         ;;
1939                 *.eli)
1940                         # Skip swap devices.
1941                         if [ "${type}" = "swap" -o "${options}" = "sw" -o "${noauto}" = "yes" ]; then
1942                                 continue
1943                         fi
1944                         devices="${devices} ${provider}"
1945                         ;;
1946                 esac
1947         done < /etc/fstab
1948
1949         # Append providers from geli_devices.
1950         devices="${devices} ${geli_devices}"
1951
1952         for provider in ${devices}; do
1953                 provider=${provider%.eli}
1954                 provider=${provider#/dev/}
1955                 devices2="${devices2} ${provider}"
1956         done
1957
1958         echo ${devices2}
1959 }
1960
1961 # Originally, root mount hold had to be released before mounting
1962 # the root filesystem.  This delayed the boot, so it was changed
1963 # to only wait if the root device isn't readily available.  This
1964 # can result in rc scripts executing before all the devices - such
1965 # as graid(8), or USB disks - can be accessed.  This function can
1966 # be used to explicitly wait for root mount holds to be released.
1967 root_hold_wait()
1968 {
1969         local wait waited holders
1970
1971         waited=0
1972         while true; do
1973                 holders="$(sysctl -n vfs.root_mount_hold)"
1974                 if [ -z "${holders}" ]; then
1975                         break;
1976                 fi
1977                 if [ ${waited} -eq 0 ]; then
1978                         echo -n "Waiting ${root_hold_delay}s" \
1979                         "for the root mount holders: ${holders}"
1980                 else
1981                         echo -n .
1982                 fi
1983                 if [ ${waited} -ge ${root_hold_delay} ]; then
1984                         echo
1985                         break
1986                 fi
1987                 sleep 1
1988                 waited=$(($waited + 1))
1989         done
1990 }
1991
1992 # Find scripts in local_startup directories that use the old syntax
1993 #
1994 find_local_scripts_old() {
1995         zlist=''
1996         slist=''
1997         for dir in ${local_startup}; do
1998                 if [ -d "${dir}" ]; then
1999                         for file in ${dir}/[0-9]*.sh; do
2000                                 grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
2001                                     continue
2002                                 zlist="$zlist $file"
2003                         done
2004                         for file in ${dir}/[!0-9]*.sh; do
2005                                 grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
2006                                     continue
2007                                 slist="$slist $file"
2008                         done
2009                 fi
2010         done
2011 }
2012
2013 find_local_scripts_new() {
2014         local_rc=''
2015         for dir in ${local_startup}; do
2016                 if [ -d "${dir}" ]; then
2017                         for file in `grep -l '^# PROVIDE:' ${dir}/* 2>/dev/null`; do
2018                                 case "$file" in
2019                                 *.sample) ;;
2020                                 *)      if [ -x "$file" ]; then
2021                                                 local_rc="${local_rc} ${file}"
2022                                         fi
2023                                         ;;
2024                                 esac
2025                         done
2026                 fi
2027         done
2028 }
2029
2030 # check_required_{before|after} command
2031 #       Check for things required by the command before and after its precmd,
2032 #       respectively.  The two separate functions are needed because some
2033 #       conditions should prevent precmd from being run while other things
2034 #       depend on precmd having already been run.
2035 #
2036 check_required_before()
2037 {
2038         local _f
2039
2040         case "$1" in
2041         start)
2042                 for _f in $required_vars; do
2043                         if ! checkyesno $_f; then
2044                                 warn "\$${_f} is not enabled."
2045                                 if [ -z "$rc_force" ]; then
2046                                         return 1
2047                                 fi
2048                         fi
2049                 done
2050
2051                 for _f in $required_dirs; do
2052                         if [ ! -d "${_f}/." ]; then
2053                                 warn "${_f} is not a directory."
2054                                 if [ -z "$rc_force" ]; then
2055                                         return 1
2056                                 fi
2057                         fi
2058                 done
2059
2060                 for _f in $required_files; do
2061                         if [ ! -r "${_f}" ]; then
2062                                 warn "${_f} is not readable."
2063                                 if [ -z "$rc_force" ]; then
2064                                         return 1
2065                                 fi
2066                         fi
2067                 done
2068                 ;;
2069         esac
2070
2071         return 0
2072 }
2073
2074 check_required_after()
2075 {
2076         local _f _args
2077
2078         case "$1" in
2079         start)
2080                 for _f in $required_modules; do
2081                         case "${_f}" in
2082                                 *~*)    _args="-e ${_f#*~} ${_f%%~*}" ;;
2083                                 *:*)    _args="-m ${_f#*:} ${_f%%:*}" ;;
2084                                 *)      _args="${_f}" ;;
2085                         esac
2086                         if ! load_kld ${_args}; then
2087                                 if [ -z "$rc_force" ]; then
2088                                         return 1
2089                                 fi
2090                         fi
2091                 done
2092                 ;;
2093         esac
2094
2095         return 0
2096 }
2097
2098 # check_jail mib
2099 #       Return true if security.jail.$mib exists and set to 1.
2100
2101 check_jail()
2102 {
2103         local _mib _v
2104
2105         _mib=$1
2106         if _v=$(${SYSCTL_N} "security.jail.$_mib" 2> /dev/null); then
2107                 case $_v in
2108                 1)      return 0;;
2109                 esac
2110         fi
2111         return 1
2112 }
2113
2114 # check_kern_features mib
2115 #       Return existence of kern.features.* sysctl MIB as true or
2116 #       false.  The result will be cached in $_rc_cache_kern_features_
2117 #       namespace.  "0" means the kern.features.X exists.
2118
2119 check_kern_features()
2120 {
2121         local _v
2122
2123         [ -n "$1" ] || return 1;
2124         eval _v=\$_rc_cache_kern_features_$1
2125         [ -n "$_v" ] && return "$_v";
2126
2127         if ${SYSCTL_N} kern.features.$1 > /dev/null 2>&1; then
2128                 eval _rc_cache_kern_features_$1=0
2129                 return 0
2130         else
2131                 eval _rc_cache_kern_features_$1=1
2132                 return 1
2133         fi
2134 }
2135
2136 # check_namevarlist var
2137 #       Return "0" if ${name}_var is reserved in rc.subr.
2138
2139 _rc_namevarlist="program chroot chdir env flags fib nice user group groups prepend"
2140 check_namevarlist()
2141 {
2142         local _v
2143
2144         for _v in $_rc_namevarlist; do
2145         case $1 in
2146         $_v)    return 0 ;;
2147         esac
2148         done
2149
2150         return 1
2151 }
2152
2153 # _echoonce var msg mode
2154 #       mode=0: Echo $msg if ${$var} is empty.
2155 #               After doing echo, a string is set to ${$var}.
2156 #
2157 #       mode=1: Echo $msg if ${$var} is a string with non-zero length.
2158 #
2159 _echoonce()
2160 {
2161         local _var _msg _mode
2162         eval _var=\$$1
2163         _msg=$2
2164         _mode=$3
2165
2166         case $_mode in
2167         1)      [ -n "$_var" ] && echo "$_msg" ;;
2168         *)      [ -z "$_var" ] && echo -n "$_msg" && eval "$1=finished" ;;
2169         esac
2170 }
2171
2172 # If the loader env variable rc.debug is set, turn on debugging. rc.conf will
2173 # still override this, but /etc/defaults/rc.conf can't unconditionally set this
2174 # since it would undo what we've done here.
2175 if kenv -q rc.debug > /dev/null ; then
2176         rc_debug=YES
2177 fi